program pretty;
{$APPTYPE CONSOLE}
uses Classes, fDirfunc, ChPos, FileScan, GetOpts; //, ACommon; //, ChPos
//another sample of GetOpts and fileScan unit

{$I PrettyName.inc}
const
  cpr = ^j +
    '------------------------------------------'^j +
    'Another sample for unit GetOpts & FileScan'^j +
    '------------------------------------------'^j +
    'Copyright (c) 2004, D.Sofyan, Adrian Hafizh & Inge DR.'^J +
    'Property of PT SOFTINDO Jakarta.'^J +
    'All rights reserved.'^j;

type
  TZtrings = array of string;
  pStatInfo = ^TStatInfo;
  TStatInfo = packed record
    Renamed, Retained: integer
  end;

var
  ListResult: TStringList;
  empret: TZtrings;

  //DirMatch,
  FileInfo, DirInfo: TStatInfo;

const
  LoX: integer = low(PrettyNames);
  HiX: integer = high(PrettyNames);

procedure initialize; //(ListResult: TStringList; empret: TZtrings);
begin
  ListResult := TstringList.Create;
  //setlength(empret, 0)
end;

procedure finalize; //(ListResult: TStringList; empret: TZtrings);
begin
  ListResult.free;
  //setlength(empret, 0);
end;

type
  TUpCaseMethod = (umUp, umLo, um83);

function UpLoFileName(const FileName: string; const StatInfo: pStatInfo; const UpMethod: TUpcaseMethod = um83): integer;
var
  fn, fnx, path: string;
  base, ext: string;
const
  DOT = '.';
begin
  Result := 0;
  fn := extractfilename(FileName);
  case upMethod of
    umUp: fnx := upperStr(fn);
    umLo: fnx := lowerStr(fn);
  else {um83:} begin
      ext := extractfileext(fn);
      base := copy(fn, 1, length(fn) - length(ext));
      //if pos(DOT, base) > 0 then base := copy(base, 1, pos(DOT, base)-1);
      if (length(base) in [1..8]) and (length(ext) <= 4) then
        fnx := upperStr(fn)
      else
        fnx := fn;
    end;
  end;
  if fn <> fnx then begin
    Result := 1;
    writeln('' + filename + ' # ' + fnx);
    path := extractfilepath(filename);
    RenameFile(filename, path + fnx);
    inc(StatInfo^.Renamed);
  end
  else begin
    writeln('' + filename + ' = ' + fnx);
    inc(StatInfo^.Retained);
  end;
end;

function Upcase83FileName(const FileName: string; const StatInfo: pointer): integer;
begin
  Result := UpLoFileName(FileName, StatInfo, um83)
end;
function UpcaseFileName(const FileName: string; const StatInfo: pointer): integer;
begin
  Result := UpLoFileName(FileName, StatInfo, umUp)
end;

function LocaseFileName(const FileName: string; const StatInfo: pointer): integer;
begin
  Result := UpLoFileName(FileName, StatInfo, umLo)
end;

function BeautifyFileName(const FileName: string; const StatInfo: pointer): integer;
const
  MAXFILENAME = ord(high(char));
var
  i, p, n, L: integer;
  path, fn, ext, fnx, prefix, mid, suffix: string;
  //pretty: TZtrings;
begin
  fn := lowerStr(extractfilename(FileName));
  ext := extractfileext(fn);
  fnx := changefileext(fn, '');
  L := length(fnx);
  fn := fnx;
  Result := 0;
  //pretty := Argumen;
  for i := Lox to hiX do begin
    p := pos(lowerStr(empret[i]), fn);
    if p > 0 then begin
      mid := empret[i];
      n := length(mid);
      prefix := copy(fnx, 1, p - 1);
      suffix := copy(fnx, p + n, L);
      fnx := prefix + mid + suffix;
    end;
  end;
  fnx := fnx + ext;
  fn := extractfilename(FileName);
  if fn <> fnx then begin
    Result := 1;
    writeln('' + filename + ' # ' + fnx);
    ListResult.Add('#' + fn + ' -> ' + fnx);
    path := extractfilepath(filename);
    RenameFile(filename, path + fnx);
    inc(pStatInfo(StatInfo)^.Renamed);
  end
  else begin
    writeln('' + filename + ' = ' + fnx);
    ListResult.Add('=' + fn + ' -> ' + fnx);
    inc(pStatInfo(StatInfo)^.Retained);
  end;
end;

procedure initPrettyName(const emprut: string; const ShowWordList: Boolean = FALSE); //(mPretty: TZtrings); //; pretty: TStrings);
const
  SECONDCHAR = 2;
  MIDLEN = 3;
  MAXLOOKUPLEN = 32;
  //EMPRUT = 'Pretty.lst';
var
  i, x: integer;
  sub: string;
  List: TStringList;
  LoX, HiX: integer;
begin
  ListResult.Clear;

  List := TstringList.Create;
  if (trimStr(emprut) <> '') and fileexists(emprut) then try
    List.LoadFromFile(EMPRUT);
  except
    List.Clear;
  end;

  LoX := low(PrettyNames);
  Hix := high(PrettyNames);
  for i := LoX to HiX do
    List.add(PrettyNames[i]);

  setlength(empret, List.Count); // may contain BLANK

  Hix := List.Count - 1;
  for i := 0 to HiX do
    empret[i] := List[i];
  for i := 0 to HiX do begin
    sub := trimStr(empret[i]);
    if (sub <> '') then
      if (length(sub) = 1) or (sub[1] = lowerStr(sub[1])) or
        ((length(sub) >= SECONDCHAR) and (sub[SECONDCHAR] = upCase(sub[SECONDCHAR]))) then
        // do not disturb all capitall/lowercase or single char
        //mPretty[i] := sub
      else begin
        sub := lowerStr(sub);
        sub[1] := upCase(sub[1]);
        //mPretty[i] := sub;
      end;
    empret[i] := sub;
  end;

  List.Clear;
  List.Sorted := TRUE;
  List.Duplicates := dupError;
  try
    Hix := high(empret);
    for i := 0 to HiX do
      if (empret[i] <> '') and (List.IndexOf(empret[i]) < 0) then
        List.Add(empret[i])
      else
        ListResult.Add(empret[i]);

    //Now BLANK has been removed//
    setlength(empret, List.Count);

    // for i := Lox to hiX do
    //   if (length(empret[i]) = MIDLEN) and (List.IndexOf(empret[i]) < 0) then
    //     List.Add(empret[i]);
    // for i := Lox to hiX do
    //   if (length(empret[i]) > MIDLEN) and (List.IndexOf(empret[i]) < 0) then
    //     List.Add(empret[i]);

    x := 0;
    for Lox := 1 to MAXLOOKUPLEN do
      for i := 0 to HiX do
        if (length(List[i]) = LoX) then begin
          empret[x] := List[i];
          inc(x);
        end;

    for i := 0 to HiX do
      if (length(List[i]) > MAXLOOKUPLEN) then begin
        empret[x] := List[i];
        inc(x);
      end;

  finally
    if ShowWordList then begin
      List.Clear;
      List.Sorted := FALSE;
      for i := 0 to high(empret) do
        List.add(empret[i]);
      writeln(List.CommaText);
    end;
    List.Free;
  end;
end;

procedure CheckResult;
const
  ROWITEMS = 8;
  COMMASPACE = ', ';
var
  i: integer;
  S: string;
begin
  S := '';
  for i := Lox to hiX do begin
    if i mod ROWITEMS > 0 then begin
      S := S + PrettyNames[i] + ', ';
    end
    else begin
      ListResult.add(S);
      S := '';
    end
  end;
end;

const
  SW_DIRS = 'd';
  SW_SUBDIR = 's';
  SW_FILES = 'f';
  SW_XFILES = 'x';
  SW_INCLUDE = 'i';
  SW_UPPER = 'u';
  SW_UP83 = 'o';
  SW_LOWER = 'l';
  SW_APPLY = 'a';
  SW_WORDS = 'w';
  SW_HELP = '?';
  SLASH = '/';
  SPACE = ' ';
  BAR = '|';

  SWU_DIRS = SLASH + char(ord(SW_DIRS) and not $20) + SPACE;
  SWU_SUBDIR = SLASH + char(ord(SW_SUBDIR) and not $20) + SPACE;
  SWU_FILES = SLASH + char(ord(SW_FILES) and not $20) + SPACE;
  SWU_XFILES = SLASH + char(ord(SW_XFILES) and not $20) + SPACE;
  SWU_INCLUDE = SLASH + char(ord(SW_INCLUDE) and not $20) + SPACE;
  SWU_UPPER = SLASH + char(ord(SW_UPPER) and not $20) + SPACE;
  SWU_UP83 = SLASH + char(ord(SW_UP83) and not $20) + SPACE;
  SWU_LOWER = SLASH + char(ord(SW_LOWER) and not $20) + SPACE;
  SWU_APPLY = SLASH + char(ord(SW_APPLY) and not $20) + SPACE;
  SWU_UPLO = SLASH + char(ord(SW_UPPER) and not $20) + BAR + char(ord(SW_LOWER) and not $20) + BAR + char(ord(SW_UP83) and not $20) + SPACE;
  SWU_WORDS = SLASH + char(ord(SW_WORDS) and not $20) + SPACE;
  SWU_HELP = SLASH + SW_HELP + SPACE;

procedure showhelp;
const
  SWM_DIRS = 'List of directories to be scanned';
  SWM_FILES = 'List of files to be scanned';
  SWM_XFILES = 'List of files to be EXCLUDED in file-scan';
  SWM_INCLUDE = 'Add custom name/wordlist in specified file';
  SWM_SUBDIR = 'Recursive down into subdirectories';
  SWM_APPLY = 'Also change directory name (not only files)';
  SWM_UPPER = 'Make UPPERCASE name instead';
  SWM_UP83 = 'Make UPPERCASE name only for DOS 8.3 Short File Name (SFN)';
  SWM_LOWER = 'Make lowercase name instead';
  SWM_WORDS = 'Show current wordlist';
  SWM_HELP = 'This help';

  files_ = 'files... ';
  dirs_ = 'directories... ';

  Synopsys = 'SYNOPSYS:'^j +
    ^i'Pretty formatted files rename'^J;
  Usage = 'USAGE:'^j;
  Usage1 =
    SWU_FILES + 'files...' + SPACE +
    SWU_XFILES + 'files...' + SPACE +
    SWU_DIRS + 'dirs... ' + SPACE +
    SWU_INCLUDE + 'wordlist' + SPACE +
    SWU_APPLY + SWU_UPLO + SWU_SUBDIR + SWU_WORDS;

  SimpleUsage = 'Or simply:' + SPACE;

  SwitchDescription = 'Known switches:'^J +
    ^i + SWU_FILES + ^i + SWM_FILES + ^j +
    ^i + SWU_XFILES + ^i + SWM_XFILES + ^j +
    ^i + SWU_DIRS + ^i + SWM_DIRS + ^j +
    ^i + SWU_INCLUDE + ^i + SWM_INCLUDE + ^j +
    ^i + SWU_APPLY + ^i + SWM_APPLY + ^j +
    ^i + SWU_UPPER + ^i + SWM_UPPER + ^j +
    ^i + SWU_UP83 + ^i + SWM_UP83 + ^j +
    ^i + SWU_LOWER + ^i + SWM_LOWER + ^j +
    ^i + SWU_SUBDIR + ^i + SWM_SUBDIR + ^J +
    ^i + SWU_WORDS + ^i + SWM_WORDS + ^j +
    ^i + SWU_HELP + ^i + SWM_HELP;

  ListDescription1 = 'List may be given as wildcards (*,?). separated by colon if more than 1';
  ListDescription2 = 'List switches can be appear several times and in anywhere, the result is'^j +
    'concatenation of all arguments';
  SW_UploDescription = 'For ON/OFF switch, the last given switch will be in effect';
  SW_IncludeDescription = 'Include file is simply a text file containing wordlist, one word per-line';
  SW_FilesDescription = 'Switch ' + SWU_FILES + 'may be omitted (optional), for any unswitched arguments'^j +
    '(ie. argument NOT preceded by known switch), will be interpreted as'^j +
    'it was an argument of ' + SWU_FILES + 'anyway';

var
  this: string;
begin
  this := upperStr(changefileext(extractfilename(Paramstr(0)), '')) + SPACE;
  writeln(cpr);
  writeln(Synopsys);
  writeln(Usage + ^i + this + Usage1 + ^j);
  writeln(^i + SimpleUsage + this + files_ + ^j);
  writeln(SwitchDescription);
  writeln;
  writeln(ListDescription1);
  writeln(ListDescription2);
  writeln;
  writeln(SW_UpLoDescription);
  writeln;
  writeln(SW_IncludeDescription);
  writeln;
  writeln(SW_FilesDescription);
end;

var
  DirCount, FileCount: integer;
  FileList, XFileList, DirList, IncludeFile: string;
  recursive: boolean;
  autoexclude: string = '';
  Uping, Loing, Up83ing: integer;
  DirProc: TFilesProcessor;
  //Attr: integer;
  //List: TStringList;
begin
  if ParamCount < 1 then
    showhelp
  else begin

    if GetOpts.SwitchIndex('?') > 0 then
      showhelp
    else begin
      if GetOpts.SwitchIndex(SW_WORDS) > 0 then begin
        Initialize;
        try
          initPrettyName(IncludeFile, TRUE); //(empret);
          writeln(ListResult.CommaText);
        finally
          finalize;
        end
      end
      else begin
        IncludeFile := GetSwitchValues(SW_INCLUDE, #0);
        FileList := GetSwitchValues(SW_FILES);
        if FileList = '' then
          FileList := GetUnSwitchedValues(SW_DIRS + SW_XFILES)
        else
          FileList := FileList + ';' + GetUnSwitchedValues(SW_DIRS + SW_XFILES);
        if FileList = '' then
          showhelp
        else begin
          autoexclude := ParamStr(0);
          DirList := GetSwitchValues(SW_DIRS);
          XFileList := GetSwitchValues(SW_XFILES);
          if XFileList <> '' then
            XFileList := XFileList + ';' + ParamStr(0)
          else
            XFileList := ParamStr(0);
          recursive := GetOpts.SwitchIndex(SW_SUBDIR) > 0;
          Uping := GetOpts.SwitchIndex(SW_UPPER);
          Up83ing := GetOpts.SwitchIndex(SW_UP83);
          Loing := GetOpts.SwitchIndex(SW_LOWER);
          DirInfo.Renamed := 0;
          DirInfo.Retained := 0;
          FileInfo.Renamed := 0;
          FileInfo.Retained := 0;

          if GetOpts.SwitchIndex(SW_APPLY) > 0 then
            DirProc := BeautifyFileName
          else
            DirProc := nil;
          //if (Uping > 0) or (Loing > 0) then begin
          //  if (Uping > 0) and (Uping > Loing) then begin
          //    if @DirProc <> nil then DirProc := UpcaseFileName;
          //    ScanFiles(DirCount, FileCount, FileList, XFileList, DirList, recursive, nil, nil,
          //      UpcaseFileName, @FileInfo, DirProc, @DirInfo)
          //  end
          //  else begin
          //    if @DirProc <> nil then DirProc := LocaseFileName;
          //    ScanFiles(DirCount, FileCount, FileList, XFileList, DirList, recursive, nil, nil,
          //      LocaseFileName, @FileInfo, DirProc, @DirInfo)
          //  end
          //end
          if (Up83ing > 0) and (Up83ing > Uping) and (Up83ing > Loing) then begin
            if @DirProc <> nil then DirProc := Upcase83FileName;
            ScanFiles(DirCount, FileCount, FileList, XFileList, DirList, recursive, nil, nil,
              Upcase83FileName, @FileInfo, DirProc, @DirInfo)
          end
          else if (Uping > 0) and (Uping > Up83ing) and (Uping > Loing) then begin
            if @DirProc <> nil then DirProc := UpcaseFileName;
            ScanFiles(DirCount, FileCount, FileList, XFileList, DirList, recursive, nil, nil,
              UpcaseFileName, @FileInfo, DirProc, @DirInfo)
          end
          else if (Loing > 0) and (Loing > Up83ing) and (Loing > Uping) then begin
            if @DirProc <> nil then DirProc := LocaseFileName;
            ScanFiles(DirCount, FileCount, FileList, XFileList, DirList, recursive, nil, nil,
              LocaseFileName, @FileInfo, DirProc, @DirInfo)
          end
          else begin
            initialize; //(ListResult, empret);
          //writeln(ListResult.Text); exit;
          //CheckResult;
            try
              initPrettyName(IncludeFile); //(empret);
              assert(empret <> nil, ^j^j'unassigned empret. it is nil!'^J^J);
              ListResult.Clear;
              ListResult.Sorted := TRUE;
              ScanFiles(DirCount, FileCount, FileList, XFileList, DirList, recursive, nil, nil,
                BeautifyFileName, @FileInfo, DirProc, @DirInfo
                );
        //ShowMsgOK(ListResult.Text);
            finally;
              finalize; //(ListResult, empret);
            end;
          end;
          writeln;
          writeln('Done scanning ', FileCount, ' file(s) in ', DirCount, ' directory(ies)');
          writeln(DirInfo.Renamed, ' dir(s) renamed, ', DirInfo.Retained, ' not changed');
          writeln(FileInfo.Renamed, ' file(s) renamed, ', FileInfo.Retained, ' not changed');
        end;
        writeln(cpr);
      end;
    end;
  end;
end.

