program ScanStr;
{$APPTYPE CONSOLE}
// Authors: aa, Adrian Hafizh & Inge DR.
// -------------------------------------
uses Classes, ChPos, fdirfunc, filescan, getOpts;
const
  ext_scanresult = '.wordlist';
  WORDLIST = 'ALLFILES' + ext_scanresult;

  help =
    '// scan string (several character classes) from files'^j +
    '// result is list of scanned string (unique) in: filename' + ext_Scanresult + ^j +
    '// (which might be used further as password scanner feeds in)'^j +
    '//'^j +
    '// Copyright 2005, Adrian Hafizh & Inge DR. of PT Softindo, Jakarta.'^j +
    '//'^j +
    '// usage:'^j +
    '//   StrScan ?|-?|-h|/?|/h /P|/S /N /L filename filenames/wildcards'^j +
    '//'^j +
    '// none any arguments is mandatory, all are optional'^j +
    '//'^j +
    '// wordbound character set argument'' s directives:'^j +
    '//   (none) : alphanumeric and underscore'^j +
    '//   /s : common phrase (alphanumeric + comma, dot and dash)'^j +
    '//   /p : all printable characters, hi-bit stripped (space to #127)'^j +
    '//        note: /p takes the higher precedence than /s'^j +
    '//'^j +
    '// additional arguments:'^j +
    '//   /n : do not sort (natural order)'^j +
    '//   /l filename: one wordlist for all'^j +
    '//      (if filename is not given, default to: ' + WORDLIST + ')'^j +
    '//    ? (as the only argument), -?,-h,/?,/h : this help'^j +
    '//'^j +
    '//   filenames/wildcards can be many values separated by semicolon (;)'^j +
    '//   default to current directory, ALL files, ALL subdirs, rescursive. :)'^j +
    '';

procedure init_000;
begin
  //ForceCurrentDirectory := TRUE;
  //KeyPreview := TRUE;
  //Font.Name := 'tahoma';
  //HintWindowClass := TMyHintWindow;
  //Position := poScreenCenter;
  //OnKeyPress := FormKeyPress;
  //Caption := 'Scan String';
  //Application.Title := 'EXAC Version 4.0';
  //WindowState := wsMaximized;
end;

var
  fWordBound1, fWordBound2, fWordBound3: set of char;
  fCharsTable: ChPos.TCharIndexTable;

procedure init_001;
begin
  fWordBound1 := ['a'..'z', 'A'..'Z', '0'..'9', '_'];
  fWordBound2 := fWordBound1 + [' ', '-', ',', '.'];
  fWordBound3 := [' '..#126];
  ChPos.initIndexTable(fCharsTable, fWordBound1);
end;

procedure init_002;
begin
end;

procedure init_003;
begin
end;

procedure init_004;
begin
end;

procedure init_005;
begin
end;

procedure init;
begin
  init_000;
  init_001; init_002;
  init_003; init_004; init_005;
end;

procedure FormCreate(Sender: TObject);
begin
  init;
end;

procedure ProcessFile(FileName: string; const Phrase, Sorted: boolean; const Log: Tstrings = nil);
const
  delimiter = ^j;

var
  S, ss: string;
  procedure SortedList(const List: TstringList);
  var
    i: integer;
  begin
    List.Sorted := TRUE;
    i := 1;
    ss := ChPos.fetchWord(S, i, delimiter);
    while i > 0 do begin
      if (List.IndexOf(ss) < 0) then List.Add(ss);
      ss := ChPos.fetchWord(S, i, delimiter);
    end;
  end;

  procedure unsortedList(const List: Tstrings);
  var
    L, SL: TstringList;
    i, x, Ctr, MaxN: integer;
    ints: array of integer;
    function foundX(const Value: integer): boolean;
    var i: integer;
    begin
      Result := FALSE;
      for i := low(ints) to high(ints) do
        if ints[i] = Value then begin
          Result := TRUE;
          break;
        end;
    end;

  begin
    L := TStringList.Create;
    SL := TStringList.Create;
    SL.Sorted := TRUE;
    try
      i := 1;
      ss := ChPos.fetchWord(S, i, delimiter);
      while i > 0 do begin
        L.Add(ss);
        if (SL.IndexOf(ss) < 0) then
          SL.Add(ss);
        ss := ChPos.fetchWord(S, i, delimiter);
      end;

      MaxN := SL.Count;
      setlength(ints, MaxN);

      for i := 0 to MaxN - 1 do ints[i] := -1;

      Ctr := 0;
      for i := 0 to L.Count - 1 do if Ctr > MaxN - 1 then break
        else begin
          ss := L[i];
          x := SL.IndexOf(ss);
          if not foundX(x) then begin
            ints[Ctr] := x;
            inc(Ctr);
          end;
        end;

      for i := low(ints) to high(ints) do begin
        x := ints[i];
        ss := SL[x];
        List.Add(ss);
      end;

    finally
      L.Free;
      SL.Free;
      setlength(ints, 0);
    end;
  end;
const
  FILE_ = 'FILE: ';
var
  L: TstringList;
begin
  if fdirfunc.fileexists(FileName) then begin
    if ChPos.SameText(fdirfunc.ExtractFileExt(filename), ext_scanresult) then writeln(' skipping: ', filename)
    else begin
      write(filename, '... ');
      S := fdirfunc.ReadStringFrom(FileName);
      if S <> '' then begin
        S := ChPos.PackWords(fCharsTable, S, delimiter);
        if S <> '' then begin
          L := TStringList.Create;
          try
            if Sorted then SortedList(L)
            else UnsortedList(L);
            if L.Count > 0 then begin
              if not assigned(Log) then
                L.SaveToFile(FileName + ext_scanresult)
              else begin
                Log.Add(FILE_ + filename);
                Log.Add(stringofChar('-', length(FILE_ + filename)));
                Log.AddStrings(L);
                Log.Add('');
              end;
              write(L.Count, ' lines');
            end;
          finally
            L.Free;
          end;
        end;
      end;
      writeln;
    end;
  end;
end;

const
  Phrase: boolean = FALSE;
  Printable: boolean = FALSE;
  OneLog: boolean = FALSE;
  Sorted: boolean = TRUE;
  Log: TstringList = nil;

var
  filecount, dircount, Ctr: integer;
  L: TstringList;
  fn, fnlist: string;

begin
  writeln;
  if (ParamStr(1) = '?') or (getOpts.SwitchIndex('?', ['/', '-']) > 0) or (getOpts.SwitchIndex('h', ['/', '-']) > 0) then
    writeln(help)
  else begin
    init;
    L := TStringList.Create;
    try
      fn := '';
      Sorted := not (getOpts.SwitchIndex('n') > 0);
      Phrase := (getOpts.SwitchIndex('s') > 0);
      Printable := (getOpts.SwitchIndex('p') > 0);
      OneLog := (getOpts.SwitchIndex('l') > 0);

      if Printable then ChPos.initIndexTable(fCharsTable, fWordBound3)
      else if Phrase then ChPos.initIndexTable(fCharsTable, fWordBound2);

      if OneLog then begin
        Log := TStringList.Create;
        fnlist := getopts.GetSwitchValues('l', #0)
      end;
      if fnList = '' then fnList := WORDLIST;

      fn := getOpts.GetUnSwitchedValues('l');

      filescan.ScanFiles(dirCount, fileCount, fn, '', '', TRUE, L);
      Ctr := L.Count;
      if Ctr > 0 then begin
        for Ctr := 0 to Ctr - 1 do
          ProcessFile(L[Ctr], Phrase, Sorted, Log);
        if assigned(Log) then Log.SaveToFile(fnList);
        writeln(^j'Done processing ', L.Count, ' files');
      end;

    finally
      L.Free;
      if assigned(Log) then Log.free;
    end;
  end;
end.

